domains 
	words=word(string,integer,integer)
	words_list=words*
	word_list =words*
	
	file=stixfile;dbase;stix
	
predicates

	base_master(word_list,word_list)
	stix_master(string,string)
	find(string,string,Word_list)
	findW(string,string,Word_list,integer,integer,integer,integer)
	read_word(string,string)
	choice_word(string)
   	sogl_col(string,integer,integer)
   	load_string(string)
   	char_type(char,integer)

goal
   	openread(stixfile,"stix.txt"),
   	 openread(dbase,"words.txt"),
   	  base_master(Words_list,Word_list),
   	   stix_master(Texts,Text),
   	    openwrite(stix,"beststix.txt"),
   	     writedevice(stix),
   	      write(Text).


clauses

base_master(Words_list,Word_list):-
	not(eof(dbase)),
	 readln(String),
	  not(String=""),
	   readint(Type_word),
	    readint(Sex),
	base_master([word(String,Type_word,Sex)|Words_list],Word_list),!.

base_master(Words_list,Word_list):-Word_list=Words_list,!.


stix_master(Word,Text):-
	readdevice(stixfile),
	 choice_word(Word1),
	  concat(Word,Word1,Texts),
	stix_master(Texts,Text),!.

stix_master(Texts,Text):-Text=Texts,!.

	 	 
choice_word(Word1):-
	 read_word(String,Word),
	  Col=0,
	   sogl_col(Word,Cols,Col),
	    find(Word,Word1,Word_list),
	     Col1=0,
	      sogl_col(Word1,Cols,Col1),
	       Col1=Col,!.
	    

read_word(String,Word):-
	load_string(String),
	 searchchar(String,' ',Position),
	  substring(String,0,Position,Word),!.
	  
	  
load_string(String):-
	str_len(String,Len),
	 Len>1,!.

load_string(String):-
	readdevice(stixfile),
	 not(eof(stixfile)),
	  readln(String),
	   str_len(String,Len),!,
	    Len>1,!.


sogl_col(Word,Col,Cols):-
	frontchar(Word,Char,End_Word),
	 not(Char=' '),
	  char_type(Char,Index),
	   Col1=Col+Index,
	    sogl_col(End_Word,Col1,Cols),!.
	    
sogl_col(Word,Col,Cols):-Cols=Col,!.
	   
	
char_type(Char,Index):-
        Char='';Char='';
	Char='';Char='';
	Char='';Char='';
	Char='';Char='';
	Char='';Char='';
	Char='';Char='';
	Char='';Char='';
	Char='';Char='';
	Char='';Char='',
	 Index=1,!.

char_type(Char,Index):-Index=0.


find(Word,Word1,Word_list):-
	findW(Word,Wordd,Word_list,Type_word,Type_wordd,Sex,Sexd),
	 findW(Word1,Wordd1,Word_list,Type_wordd,Type_word,Sexd,Sex),!.
	 
findW(Word,Wordd,[Head|Tail],Type_word,Type_wordd,Sex,Sexd):-
	not(Head=word(Word,Type_word,Sex)),
	 findW(Word,Wordd,Tail,Type_word,Type_wordd,Sex,Sexd),!.
	 
findW(Word,Wordd,_,Type_word,Type_wordd,Sex,Sexd):-
	Wordd=Word,Type_wordd=Type_word,Sexd=Sex,!.
		